pro trace_time2level1, tstart, tstop, pindex, pdata, $
    testarray=testarray, mcnt=mcnt, _extra=_extra, $
    writeit=writeit, soho=soho, outdir=outdir, outfiles=outfiles,$
    maxfiles=maxfiles

;+
;   Name: tace_time2level1
;
;   Purpose: map from event times to TRACE L1 data; optionally write->file
;
;   Input Parameters:
;      tstart, tstop - time range of interest
; 
;   Output Parameters:
;      pindex, pdata - optionally return level1 index,data
;
;   Keyword Parameters:
;      testarray - parameter TEST_ARRRAY per 'struct_where.pro'
;      _extra    -    keyword inherit keywords -> trace_prep
;      soho      - switch - if set, write with synoptic dbase filenames
;      synoptic  - switch - synonym for /SOHO
;      mcnt (output) - number of TRACE images matching (and written if app.)
;
;   Calls:
;      trace_cat, struct_where, trace_cat2data, trace_prep, write_trace
;
;   History:
;      27-Feb-2001 - S.L.Freeland 
;-

writeit=keyword_set(writeit) or keyword_set(soho) or keyword_set(outdir)          ; output file?
if not data_chk(testarray,/string) then $                  ; parameter filter
 testarray=['wave_len=171,195,wl,1216,1600','naxis1>=512'] ; some default

trace_cat, tstart, tstop, tcat                      ; event -> trace catalog
ss=struct_where(tcat,test=TESTARRAY,mcnt)           ; parameter filter
if keyword_set(maxfiles) then begin 
   if maxfiles lt mcnt then begin 
      sss=grid_data(tcat(ss),nsamp=maxfiles,/ss)
      ss=ss(sss)
   endif
endif
if mcnt gt 0 then begin                             ; any matches?
   trace_cat2data,tcat(ss),index,data               ; cat matches -> index,data
   trace_prep,index,data,pindex,pdata,_extra=_extra ; L0->L1
;  [optional scaling]                               ;
   if writeit then begin                               ; L1->file?
      delvarx,outfile
      write_trace,pindex,pdata,/soho,outfile=outfile, outdir=outdir  ; flat fits w/SYNOP names
      outfiles=outfile 
    endif

endif else box_message,'No matching images'

return
end

